Last Comment Bug 532240 - implement NJ_EXPANDED_LOADSTORE_SUPPORTED for x64 backend
: implement NJ_EXPANDED_LOADSTORE_SUPPORTED for x64 backend
Status: RESOLVED FIXED
fixed-in-nanojit fixed-in-tamarin, fi...
:
Product: Core Graveyard
Classification: Graveyard
Component: Nanojit (show other bugs)
: unspecified
: x86_64 All
: -- normal (vote)
: Future
Assigned To: Steven Johnson
:
:
Mentors:
Depends on: 533854
Blocks:
  Show dependency treegraph
 
Reported: 2009-12-01 16:54 PST by Steven Johnson
Modified: 2014-03-17 08:00 PDT (History)
2 users (show)
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Patch (16.84 KB, patch)
2009-12-08 16:56 PST, Steven Johnson
n.nethercote: review+
Details | Diff | Splinter Review
Patch #2 (18.55 KB, patch)
2009-12-09 15:19 PST, Steven Johnson
edwsmith: review+
n.nethercote: review+
Details | Diff | Splinter Review

Description Steven Johnson 2009-12-01 16:54:18 PST

    
Comment 1 Steven Johnson 2009-12-08 16:56:17 PST
Created attachment 416667 [details] [diff] [review]
Patch

Initial implementation.
Comment 2 Nicholas Nethercote [:njn] 2009-12-08 17:48:12 PST
Comment on attachment 416667 [details] [diff] [review]
Patch

>@@ -438,6 +443,8 @@
>+    void Assembler::CVTSS2SD(R l, R r)  { emitprr(X64_cvtss2sd,l,r); asm_output("cvtss2sd %s, %s",RQ(l),RL(r)); }
>+    void Assembler::CVTSD2SS(R l, R r)  { emitprr(X64_cvtsd2ss,l,r); asm_output("cvtsd2ss %s, %s",RQ(l),RL(r)); }

I think the RQ/RL calls should be reversed in the second one.


>+    void Assembler::MOVBMR(R r1, I d, R r2)     { emitrm8(X64_movbmr,r1,d,r2); asm_output("movb %d(%s), %s",d,RQ(r1),RL(r2)); }
>+    void Assembler::MOVSMR(R r1, I d, R r2)     { emitrm_wide(X64_movsmr,r1,d,r2); asm_output("movs %d(%s), %s",d,RQ(r1),RL(r2)); }

For the first one, RL(r2) should be RB(r2), I think.  And we need to add RS() for the second one.

It's probably worth re-checking all the other RQ/RL calls for similar problems.

With those fixed, r=me.
Comment 3 Steven Johnson 2009-12-08 17:59:24 PST
Comment on attachment 416667 [details] [diff] [review]
Patch

buggy, new patch coming soon
Comment 4 Steven Johnson 2009-12-09 15:19:07 PST
Created attachment 416813 [details] [diff] [review]
Patch #2

Improved (functional) patch.
Comment 5 Steven Johnson 2009-12-11 16:22:40 PST
pushed to nj-c as changeset:   1106:cd0b46495c95
Comment 6 Steven Johnson 2009-12-11 16:25:17 PST
pushed to tr as changeset:   3309:61d155d042c7
Comment 7 Nicholas Nethercote [:njn] 2009-12-20 14:46:29 PST
http://hg.mozilla.org/tracemonkey/rev/c1206e65e43f (on December 11, 2009)
http://hg.mozilla.org/tracemonkey/rev/55d3f8fc69fc
Comment 8 Steven Johnson 2009-12-23 09:57:43 PST
Pretty sure that this has been pushed to all relevant repos, shall we close it?
Comment 9 Steven Johnson 2010-01-04 09:45:27 PST
Nick, since this is (pretty much) closed out, shall I remove your outstanding r?
Comment 10 Nicholas Nethercote [:njn] 2010-01-04 14:00:26 PST
Comment on attachment 416813 [details] [diff] [review]
Patch #2

Sorry, missed that.  Fixed now.

Note You need to log in before you can comment on or make changes to this bug.